const debug = require('debug');
const _ = require('lodash');

const log = debug('proxy');

const getNameReg = /^\/([^/]+)(\/.*)$/;

const REWRITE_MAX = 10;

class MockProxyRulesSheetList extends Map {
  match(req, count = 1) {
    log('match', req.url, count);
    if (req.records) {
      req.records.push(req.url);
    }
    if (count > REWRITE_MAX) {
      throw new Error(`rewrite 超过${REWRITE_MAX}次`);
    }
    const res = getNameReg.exec(req.url);
    if (!res) {
      throw new Error(`url(${req.url})不符合规则`);
    }

    const name = res[1];
    req.url = res[2]; // eslint-disable-line prefer-destructuring

    if (!this.has(name)) {
      return null;
    }
    const target = this.get(name).match(req);
    if (target && _.startsWith(target[0], '/')) {
      log(`rewrite ${target}`);
      req.url = target;
      return this.match(req, count + 1);
    }
    return target;
  }
}

module.exports = MockProxyRulesSheetList;
